-- Love3D : Perspective Demo --

function love.load()
	monitorWidth = 1024
	monitorHeight = 768
	love.graphics.setMode(monitorWidth, monitorHeight, false, true, 3)
	
	ball = {}
	ball.x = monitorWidth/2
	ball.y = monitorHeight/2
	ball.xPos = ball.x
	ball.yPos = ball.y
	ball.zPos = 0
	ball.scale = 1
	
	vpX = monitorWidth/2
	vpY = monitorHeight/2
	fl = 250
end

function love.update()
	if love.keyboard.isDown("q") then
		ball.zPos = ball.zPos + 0.5
	elseif love.keyboard.isDown("e") then
		ball.zPos = ball.zPos - 0.5
	end
	
	if ball.zPos > fl * -1 then
		ball.xPos = love.mouse.getX() - vpX
		ball.yPos = love.mouse.getY() - vpY
		local scale = fl / (fl + ball.zPos)
		ball.scale = scale
		ball.x = vpX + ball.xPos * scale
		ball.y = vpY + ball.yPos * scale
	end
end

function love.draw()
	love.graphics.circle("fill", ball.x, ball.y, 10 * ball.scale, 25)
end